/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.audit.action;

import java.text.DateFormat;
import java.util.List;
import java.util.Locale;

import it.eng.console.audit.bo.ProcessInstanceBO;
import it.eng.console.endpoint.action.EndPointDetailAction;
import it.eng.console.process.bo.ProcessBO;
import it.eng.spagosoa.metadb.base.ServiceAssemblyStateConstants;
import it.eng.spagosoa.metadb.model.Endpoint;
import it.eng.spagosoa.metadb.model.JournalInstanceService;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractAction;
import it.eng.spago.message.MessageBundle;

public class JournalInstancesAction extends EndPointDetailAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		long endPointId = Long.parseLong((String)serviceRequest.getAttribute("endPointId"));
		long processInstanceId = Long.parseLong((String)serviceRequest.getAttribute("processInstanceId"));
		
		SourceBean journalInstancesBean = createDetailBean(endPointId);
		SourceBean endPointPropertiesBean = createPropertiesBean(endPointId);
		journalInstancesBean.setAttribute(endPointPropertiesBean);
		
		SourceBean journalInstancesListBean = new SourceBean("JOURNAL_INSTANCES_LIST");
		List journalInstancesList = ProcessInstanceBO.getJournalInstanceService(endPointId, processInstanceId);
		SourceBean journalInstanceBean = null;
		JournalInstanceService journalInstance = null;
		String stateId = null;
		for(int index=0; index<journalInstancesList.size(); index++) {
			journalInstance = (JournalInstanceService)journalInstancesList.get(index);
			journalInstanceBean = new SourceBean("ITEM");
			journalInstanceBean.setAttribute("id", journalInstance.getIdJournal());
			stateId = Integer.toString(journalInstance.getMepState().getIdState());
			journalInstanceBean.setAttribute("stato", MessageBundle.getMessage(stateId, "properties.console.console"));
			
			DateFormat formatter = DateFormat.getTimeInstance(DateFormat.SHORT, Locale.ITALY);
			String dateTemp = formatter.format(journalInstance.getExchangeStart());					
			journalInstanceBean.setAttribute("inizio", dateTemp);	
			journalInstancesListBean.setAttribute(journalInstanceBean);
		}
		journalInstancesBean.setAttribute(journalInstancesListBean);
		serviceResponse.setAttribute(journalInstancesBean);
	}

}
