package it.eng.console.audit.bean;

import java.util.List;
import it.eng.console.audit.bo.ProcessInstanceBO;

public class RestartedBeanFE implements java.io.Serializable{
	private String process;
	private long processId;
	private long idOriginal;
	private int state;
	private long idRestarted;
	private String message;
	private boolean instanceOriginalRestarted = false;
	
	public static final String CORRELATION_ID_PREFIX = "RESTARTED_ID:";
	
	public RestartedBeanFE(long idOriginal, long idRestarted, String message) {
		this.idOriginal = idOriginal;
		this.idRestarted = idRestarted;
		this.message = (message != null) ? message : "";
	}
	
	public void load() {
		List originalInfo = ProcessInstanceBO.getInstanceSummaryInfo(idOriginal);
		process = (String)originalInfo.get(0);
		state = (Integer)originalInfo.get(1);
		processId = (Long)originalInfo.get(2);
		if (((String)originalInfo.get(3)).startsWith(CORRELATION_ID_PREFIX))
			instanceOriginalRestarted = true;
	}

	public long getIdOriginal() {
		return idOriginal;
	}

	public long getIdRestarted() {
		return idRestarted;
	}

	public String getMessage() {
		return message;
	}

	public String getProcess() {
		return process;
	}
	
	public long getProcessId() {
		return processId;
	}

	public int getState() {
		return state;
	}

	public boolean isInstanceOriginalRestarted() {
		return instanceOriginalRestarted;
	}
	
}
