package it.eng.console.audit.paginator;

import java.util.ArrayList;

import it.eng.console.audit.bean.RestartedBeanFE;
import it.eng.spagosoa.smx.components.restart.client.RestartResult;

public class InstancesRestartedPaginator implements java.io.Serializable{

	private long[] idOriginalList;
	private RestartResult[] idRestartedList;
	private int page;
	private int pageSize;
	
	public InstancesRestartedPaginator(long[] idOriginalList, RestartResult[] idRestartedList, int pageSize) {
		this.idOriginalList = idOriginalList;
		this.idRestartedList = idRestartedList;
		this.page = 0;
		this.pageSize = pageSize;
	}
	
	public void setNextPage() {
		if (hasNextPage())
			this.page += 1;
	}
	
	public void setPrevPage() {
		if(page>0)
			this.page -= 1;
	}
	
	public void setFirstPage() {
		this.page = 0;
	}	
	
	public boolean hasNextPage() {
		int sizeList = idOriginalList.length;
		if((sizeList / pageSize) == page && (sizeList % pageSize == 0))
			return false;
		else 
			return true;
	}
	
	public ArrayList getResult() {
		ArrayList result = new ArrayList();
		int index;
		RestartedBeanFE beanFE = null;
		RestartResult restartResult = null;
		int startIndex= page*pageSize;
		for (index=startIndex; index<startIndex+pageSize && index<idOriginalList.length; index++) {
			restartResult = idRestartedList[index];
			beanFE = new RestartedBeanFE(idOriginalList[index], restartResult.getRestartedInstanceId(), restartResult.getErrorMessage());
			beanFE.load();
			result.add(beanFE);
		}
		return result;
	}

}
