/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.process.action;

import java.io.PrintWriter;

import it.eng.console.parser.SvgParser;
import it.eng.console.util.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractHttpAction;
import it.eng.spago.tracing.TracerSingleton;

public class SvgGraphAction extends AbstractHttpAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {
		String processId = (String)serviceRequest.getAttribute("processId");		
		String processInstanceId = (String)serviceRequest.getAttribute("processInstanceId");
		
		SvgParser parser = null;
		PrintWriter out = getHttpResponse().getWriter();
		try {
			if(processInstanceId == null) {	
				parser = new SvgParser((new Long(processId)).longValue());			
				out.println(parser.createProcessSvgString());
			} else {			
				parser = new SvgParser((new Long(processId)).longValue(), (new Long(processInstanceId)).longValue());			
				out.println(parser.createProcessInstanceSvgString());	
			}
		} catch(NullPointerException npe) {
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "SvgGraphAction::service: ", npe);
			out.println("Impossibile visualizzare il grafo");
		}
		out.close();		
	}
}
