/**

Copyright 2004, 2007 Engineering Ingegneria Informatica S.p.A.

This file is part of Spago.

Spago is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
any later version.

Spago is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Spago; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/

package it.eng.console.tag;

import it.eng.spago.base.Constants;
import it.eng.spago.tracing.TracerSingleton;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import it.eng.spago.message.MessageBundle;

/**
 * @author Butano
 */
public class LabelTag extends TagSupport {

    private String _id = null;
	private String _bundle = "properties.spagic";

	public LabelTag() {
		super();
	}
	
	public int doStartTag() throws JspException {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.INFORMATION, "LabelTag::doStartTag:: invocato");        
        String label = MessageBundle.getMessage(_id, _bundle);
        StringBuffer htmlStream = new StringBuffer();
        htmlStream.append(label); 
       
        try {
            pageContext.getOut().print(htmlStream);
        } 
        catch (Exception ex) {
            TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL,
                "LabelTag::doStartTag:: Impossibile inviare lo stream");
            throw new JspException("Impossibile inviare lo stream");
        } 
        return SKIP_BODY;
	}
	
	
    public String getId() {
		return _id;
	}

	public void setId(String _id) {
		this._id = _id;
	}

	public int doEndTag() throws JspException {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.INFORMATION, "MessageTag::doEndTag:: invocato");
        return super.doEndTag();
    }

}
