/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.jmx.action;

import it.eng.console.util.Constants;
import it.eng.jmx.bo.JmxBO;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.dispatching.action.AbstractAction;
import it.eng.spago.tracing.TracerSingleton;

public class QueueAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "QueueAction::service:invocato");
		//input parameter 
		String idServer = 
			(serviceRequest.getAttribute(it.eng.jmx.util.Constants.LBL_SELECTED_SERVER)!=null)
			? (String)serviceRequest.getAttribute(it.eng.jmx.util.Constants.LBL_SELECTED_SERVER)
			: (String)ConfigSingleton.getInstance().getAttribute("SERVERS.default");
        serviceResponse.updAttribute(it.eng.jmx.util.Constants.LBL_SELECTED_SERVER, idServer);
       
		serviceResponse.setAttribute(it.eng.jmx.util.Constants.LBL_QUEUE, JmxBO.getQueue(idServer));
		serviceResponse.setAttribute(it.eng.jmx.util.Constants.LBL_TOPIC, JmxBO.getTopic(idServer));
	}
}
