/**

SpagoBI - The Business Intelligence Free Platform

Copyright (C) 2005 Engineering Ingegneria Informatica S.p.A.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spagobi.bo.dao.hibernate;


import it.eng.spagobi.constants.AdmintoolsConstants;
import it.eng.spagobi.constants.SpagoBIConstants;
import it.eng.spagobi.metadata.HibernateUtil;
import it.eng.spagobi.utilities.SpagoBITracer;

import org.hibernate.Session;



/**
 * Abstract class that al DAO will have to extend.
 * 
 * @author Zoppello
 */
public class AbstractHibernateDAO {
	/**
	 * Gets tre current session.
	 * @return The current session object.
	 */
	public Session getSession(){
		return HibernateUtil.currentSession();
	}
	/**
	 * Traces the exception information of a throwable input object
	 * @param t The input throwable object
	 */
	public void logException(Throwable t){
		SpagoBITracer.major(SpagoBIConstants.NAME_MODULE, 
				            t.getClass().getName(), 
				            "", 
				            t.getMessage());
	}
}
